﻿<?php

abstract class Animal implements ISoundable {
    // декларираме read-only property
    public function getName() {
        return $this->name;
    }
    private $name;
    
    // декларираме read-only property
    public function getIsAsleep() {
        return $this->isAsleep;
    }
    private $isAsleep;
    
    // декларираме три конструктора на класа и използваме параметри по подразбиране,
	// за да определим начина, по който е извикан (PHP не поддържа overloads)
    protected function __construct($name = null, $isAsleep = null) {
        // никое животно не обича да си остава без име
        if(empty($name))
            throw new AnimalException("Името на животното не може да е празно!");
        $this->name = $name;
		$this->isAsleep = $isAsleep;
        
        print("Създадох животно с име: " . $this->name . "\n");
    }
    
    // приспиване на животното
    public function sleep() {
        if ($this->isAsleep)
            throw new AnimalException("Животното вече спи.");
        
        print("Животното заспа.\n");
    }
    
    // събуждане на животното
    public function wakeUp() {
        if ($this->isAsleep)
            throw new AnimalException("Животното вече е будно.");
        
        print("Животното се събуди.\n");
    }
    
    // ISoundable Members
    //public abstract function sound();
}
?>