﻿<pre>
<?php
function __autoload($className)
{
	require_once('./' . $className . '.class.php');
}

//! Класът Animal е абстрактен и не може да бъде инстанцииран
// $animal = new Animal('Пепи');
//! Конструкторите на класа Cat са private и той не може да бъде инстанцииран
// $animal = new Cat('Жорко');

try
{
	$unnamedAnimal = new Dog(null, true);
	print($unnamedAnimal->getName() . "\n");
}
catch (AnimalException $ex)
{
	// До дук се стига, когато хвърленото изключение/exception не е прихванато по-рано
	// и е от клас AnimalException или някой от неговите наследници
	print("Не можах да създам котка, защото: " . $ex->getMessage() . "\n");
}

// Този код се извиква винаги, с изключение на случаите, когато catch блокът
// хвърля изключение.
print("Въпреки това продължавам работата си!\n");

// Създаваме куче (Dog) с име "Валери".
$animal = new Dog('Валери');

// Въпреки имплицитният typecast, истинският тип на създадения обект е известен
print("Класът на създаденото животно е: " . get_class($animal) . "\n");

$animal->sound();

// Създаваме възможно най-голям брой котки, като ги пускаме да подлудят квартала
// с мяукане:
for($i = 0;; $i++)
{
	try
	{
		$animal = Cat::createCat("Жорко #" . ($i + 1));
		$animal->sound();
	}
	catch (AnimalException $ex)
	{
		// ако вече не можем да създадем котка, излизаме от цикъла
		print("Не стана. Създадох общо " . Cat::getTotalCats() . " котки!\n");
		break;
	}
}

// Alien класът няма нищо общо с класовете Dog, Cat и Animal, но фактът, че
// имплементира ISoundable е достатъчен, за да сме сигурни, че има метод Sound().
$alien = new Alien();
$alien->sound();
?>
</pre>